/* opcodes.h - merlin instruction definitions */

#ifndef __OPCODES_H__
#define __OPCODES_H__

/* opcodes */
typedef enum {

    base_nop,
      op_nop = base_nop,
    base_abs,
      op_abs_sr = base_abs,
    base_add,
      op_add_sr_sr = base_add,
      op_add_uimm_sr,
      op_add_sr_sr_sr,
      op_add_uimm_sr_sr,
      op_add_uimm10_sr,
      op_add_uimm_rotate_imm_sr,
      op_add_sr_uimm_sr,
      op_add_uimm_shift_sr_sr,
      op_add_sr_shift_imm_sr,
      op_add_sr_shift_sr_sr,
    base_add_sv,
      op_add_sv_vr_vr = base_add_sv,
      op_add_sv_vr_vr_vr,
    base_sub,
      op_sub_sr_sr = base_sub,
      op_sub_uimm_sr,
      op_sub_sr_sr_sr,
      op_sub_uimm_sr_sr,
      op_sub_uimm10_sr,
      op_sub_uimm_rotate_imm_sr,
      op_sub_sr_uimm_sr,
      op_sub_uimm_shift_sr_sr,
      op_sub_sr_shift_imm_sr,
      op_sub_sr_shift_sr_sr,
    base_sub_sv,
      op_sub_sv_vr_vr = base_sub_sv,
      op_sub_sv_vr_vr_vr,
    base_cmp,
      op_cmp_sr_sr = base_cmp,
      op_cmp_uimm_sr,
      op_cmp_uimm10_sr,
      op_cmp_uimm_rotate_imm_sr,
      op_cmp_sr_uimm,
      op_cmp_uimm_shift_sr_sr,
      op_cmp_sr_shift_imm_sr,
      op_cmp_sr_shift_sr_sr,
    base_and,
      op_and_sr_sr = base_and,
      op_and_sr_sr_sr,
      op_and_imm_sr_sr,
      op_and_imm_rotate_imm_sr,
      op_and_imm_shift_sr_sr,
      op_and_sr_shift_imm_sr,
      op_and_sr_shift_sr_sr,
      op_and_sr_rotate_sr_sr,
    base_or,
      op_or_sr_sr = base_or,
      op_or_sr_sr_sr,
      op_or_imm_sr_sr,
      op_or_imm_rotate_imm_sr,
      op_or_imm_shift_sr_sr,
      op_or_sr_shift_imm_sr,
      op_or_sr_shift_sr_sr,
      op_or_sr_rotate_sr_sr,
    base_eor,
      op_eor_sr_sr = base_eor,
      op_eor_sr_sr_sr,
      op_eor_imm_sr_sr,
      op_eor_imm_rotate_imm_sr,
      op_eor_imm_shift_sr_sr,
      op_eor_sr_shift_imm_sr,
      op_eor_sr_shift_sr_sr,
      op_eor_sr_rotate_sr_sr,
    base_neg,
      op_neg_sr = base_neg,
    base_not,
      op_not_sr = base_not,
    base_bits,
      op_bits_uimm_shift_uimm_sr = base_bits,
    base_as,
      op_as_sr_sr_sr = base_as,
    base_asl,
      op_asl_uimm_sr = base_asl,
      op_asl_uimm_sr_sr,
    base_asr,
      op_asr_uimm_sr = base_asr,
      op_asr_uimm_sr_sr,
    base_ls,
      op_ls_sr_sr_sr = base_ls,
    base_lsl,
      op_lsl_uimm_sr = base_lsl,
      op_lsl_uimm_sr_sr,
    base_lsr,
      op_lsr_uimm_sr = base_lsr,
      op_lsr_uimm_sr_sr,
    base_msb,
      op_msb_sr_sr = base_msb,
      op_msb_sr_sr_sr,
      op_msb_imm_sr_sr,
    base_bclr,
      op_bclr_uimm_sr = base_bclr,
    base_bset,
      op_bset_uimm_sr = base_bset,
    base_btst,
      op_btst_uimm_sr = base_btst,
      op_btst_imm_rotate_imm_sr,
      op_btst_imm_shift_sr_sr,
      op_btst_sr_shift_imm_sr,
      op_btst_sr_shift_sr_sr,
    base_copy,
      op_copy_sr_sr = base_copy,
    base_butt,
      op_butt_sr_sr = base_butt,
      op_butt_sr_sr_sr,
    base_dotp,
      op_dotp_sr_vr_shift_sv_shift_sr = base_dotp,
      op_dotp_sr_vr_shift_mulimm_sr,
      op_dotp_vr_vr_shift_sv_shift_sr,
      op_dotp_vr_vr_shift_mulimm_sr,
    base_mul,
      op_mul_sr_sr = base_mul,
      op_mul_sr_sr_shift_ac_shift_sr,
      op_mul_sr_sr_shift_uimm_sr,
      op_mul_sr_sr_shift_sr_sr,
      op_mul_uimm_sr_shift_ac_shift_sr,
      op_mul_uimm_sr_shift_uimm_sr,
      op_mul_uimm_sr_shift_sr_sr,
    base_mul_p,
      op_mul_p_sr_vr_shift_sv_shift_vr = base_mul_p,
      op_mul_p_sr_vr_shift_mulimm_vr,
      op_mul_p_ruv_vr_shift_sv_shift_vr,
      op_mul_p_ruv_vr_shift_mulimm_vr,
      op_mul_p_vr_vr_shift_sv_shift_vr,
      op_mul_p_vr_vr_shift_mulimm_vr,
    base_mul_sv,
      op_mul_sv_vr_vr = base_mul_sv,
      op_mul_sv_sr_vr_shift_sv_shift_vr,
      op_mul_sv_sr_vr_shift_mulimm_vr,
      op_mul_sv_ruv_vr_shift_sv_shift_vr,
      op_mul_sv_ruv_vr_shift_mulimm_vr,
      op_mul_sv_vr_vr_shift_sv_shift_vr,
      op_mul_sv_vr_vr_shift_mulimm_vr,
    base_addm,
      op_addm_sr_sr_sr = base_addm,
    base_subm,
      op_subm_sr_sr_sr = base_subm,
    base_buttm,
      op_buttm_sr_sr = base_buttm,
      op_buttm_sr_sr_sr,
    base_addr,
      op_addr_ruimm_rur_rc_rc = base_addr,
      op_addr_sr_rur_rc_rc,
    base_mv_spr,
      op_mv_spr_pc_rz_rc_rc = base_mv_spr,
    base_ld_io,
      op_ld_io_ind_io_sr = base_ld_io,
      op_ld_io_ind_io_vr,
    base_ld_p,
      op_ld_p_ind_bilinear_pr = base_ld_p,
    base_ld_s,
      op_ld_s_ind_sr_sr = base_ld_s,
      op_ld_s_dsoff4_sr,
      op_ld_s_ind_bilinear_sr,
    base_ld_sv,
      op_ld_sv_ind_sr_vr = base_ld_sv,
      op_ld_sv_dsoff8_vr,
      op_ld_sv_ind_bilinear_vr,
    base_ld_v,
      op_ld_v_ind_sr_vr = base_ld_v,
      op_ld_v_dsoff16_vr,
    base_st_io,
      op_st_io_sr_ind_io = base_st_io,
      op_st_io_imm_ind_io,
      op_st_io_vr_ind_io,
    base_st_p,
      op_st_p_pr_ind_bilinear = base_st_p,
    base_st_s,
      op_st_s_sr_ind_sr = base_st_s,
      op_st_s_sr_dsoff4,
      op_st_s_sr_ind_bilinear,
    base_st_sv,
      op_st_sv_vr_ind_sr = base_st_sv,
      op_st_sv_vr_dsoff8,
      op_st_sv_vr_ind_bilinear,
    base_st_v,
      op_st_v_vr_ind_sr = base_st_v,
      op_st_v_vr_dsoff16,
    base_mv_s,
      op_mv_s_sr_sr = base_mv_s,
      op_mv_s_imm_sr,
      op_mv_s_imm32_sr,
    base_mv_v,
      op_mv_v_vr_vr = base_mv_v,
    base_push,
      op_push_vr = base_push,
      op_push_vr_rz,
    base_pop,
      op_pop_vr = base_pop,
      op_pop_vr_rz,
    base_bra,
      op_bra_cc_imm = base_bra,
      op_bra_imm,
    base_jmp,
      op_jmp_cc_imm_stallop = base_jmp,
      op_jmp_cc_ind_sr_stallop,
    base_rts,
      op_rts_cc_ind_rz = base_rts,
    base_halt,
      op_halt = base_halt,
    max_opcode

} Opcode;

#endif
