/* mpdll.h - definitions for the MPARSE DLL */

#ifndef __MPDLL_H__
#define __MPDLL_H__

#ifndef EXPORT
#ifdef WIN32
#include <windows.h>
#define EXPORT	__declspec(dllexport)
#else
#define EXPORT
#endif
#endif

/* flags */
#define mpfOutputTables 1
#define mpfOutputBinary 2

/* status codes */
#define mpsSuccess      0	/* must be zero for setjmp */
#define mpsInputFile    1
#define mpsOutputFile	2
#define mpsError        3

/* buffer sizes */
#define MPERRTEXTSIZE	256
#define MPERRFILESIZE	256

/* error information structure */
typedef struct {
    int status;
    char text[MPERRTEXTSIZE];
    char file[MPERRFILESIZE];
    long line;
    long offset;
} mpErrorInfo;

/* prototypes */
EXPORT int mpAssemble(char *ifile,
		      char *ofile,
		      int flags,
		      mpErrorInfo *errInfo);

#endif
